import requests
import settings


def led_run(id_led, start, stop, bri, fx, sx, ix, pal):
    red, green, blue = settings.color
    segment = {
        "id": id_led,
        "start": start,
        "stop": stop,
        "len": 36,
        "grp": 1,
        "spc": 0,
        "on": 'true',
        "bri": bri,
        "col": [[red, green, blue], [0, 0, 0], [0, 0, 0]],
        "fx": fx,
        "sx": sx,
        "ix": ix,
        "pal": pal,
        "sel": 'true',
        "rev": 'false',
        "mi": 'false'}
    return segment


zone_start_1 = settings.zone_1[0]
zone_start_2 = settings.zone_2[0]
zone_start_3 = settings.zone_3[0]
zone_start_4 = settings.zone_4[0]
zone_end_1 = settings.zone_1[1]
zone_end_2 = settings.zone_2[1]
zone_end_3 = settings.zone_3[1]
zone_end_4 = settings.zone_4[1]

percent = settings.percent
led_effect_index = settings.led_effect_index[0]
speed = settings.speed[0]
intensity = settings.intensity[0]
palette = settings.palette[0]
ip_address = settings.ip_address

url = f'http://{ip_address}/json/state'

r = requests.get(url)
brightness = r.json()['bri']

brightness_percent = round(255 / 100 * percent)
zone_brightness = brightness + brightness_percent
if zone_brightness >= 255:
    zone_brightness = 255

requests.post(url, json=({"seg": led_run(id_led=2, start=zone_start_3, stop=zone_end_3, bri=zone_brightness,
                                         fx=led_effect_index, pal=palette, sx=speed, ix=intensity)}))
requests.post(url, json=({"seg": led_run(id_led=0, start=zone_start_1, stop=zone_end_1, bri=brightness,
                                         fx=led_effect_index, pal=palette, sx=speed, ix=intensity)}))
requests.post(url, json=({"seg": led_run(id_led=1, start=zone_start_2, stop=zone_end_2, bri=brightness,
                                         fx=led_effect_index, pal=palette, sx=speed, ix=intensity)}))
requests.post(url, json=({"seg": led_run(id_led=3, start=zone_start_4, stop=zone_end_4, bri=brightness,
                                         fx=led_effect_index, pal=palette, sx=speed, ix=intensity)}))
